// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the MEMLEAKDLL_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// MEMLEAKDLL_API functions as being imported from a DLL, whereas this DLL sees symbols
// defined with this macro as being exported.

#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers
#include <windows.h>

#ifdef MEMLEAKDLL_EXPORTS
#define MEMLEAKDLL_API __declspec(dllexport)
#else
#define MEMLEAKDLL_API __declspec(dllimport)
#endif

MEMLEAKDLL_API void* TraceAlloc(size_t nSize);
MEMLEAKDLL_API void TraceDealloc(void* poMem);


/* Used for tracking allocations */
MEMLEAKDLL_API void* XWBMalloc (
    size_t iSize,
    const char* iFile,
    const size_t iLine);
MEMLEAKDLL_API void* XWBCalloc (
    size_t iNum,
    size_t iSize,
    const char* iFile,
    const size_t iLine);
MEMLEAKDLL_API char* XWBStrDup (
    const char* iOrig,
    const char* iFile,
    const size_t iLine);
/* Used for tracking reallocations */
MEMLEAKDLL_API void* XWBRealloc (
    void* iPrev,
    size_t iSize,
    const char* iFile,
    const size_t iLine);
/* Used for tracking deallocations */
MEMLEAKDLL_API void  XWBFree (
    void* iPtr,
    const char* iDesc,
    const char* iFile,
    const size_t iLine);
/* Used for reporting */
MEMLEAKDLL_API void  XWBReport (const char* iTag);
MEMLEAKDLL_API void  XWBMemNew (void);
MEMLEAKDLL_API void  XWBReportFinal (void);
/* Used for detecting FMW */
MEMLEAKDLL_API void  XWBNoFree (void);
MEMLEAKDLL_API void  XWBPreallocate (const int iInitialAllocations);
